/******************************************************************************
 *
 * Copyright (c) 1999	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	Filesv.cpp
 *
 *****************************************************************************/

// SOL++2000
// 2000.02.18

#include "filelsv.h"

FileListView::FileListView(View* parent, const char* name, Args& args)
	:ListView(parent, name, args)
{
	setTextColor(RGB(0,0,255));
}


void FileListView::findFiles(char* dir)
{
	WIN32_FIND_DATA data;

	char* buffer = new char[_MAX_PATH];
	sprintf(buffer, "%s\\*", dir);
	HANDLE fFile= ::FindFirstFile(buffer, &data);

	if(fFile != INVALID_HANDLE_VALUE) {
		do {
			if (!(data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
				if (strcmp(".", data.cFileName) != 0 && strcmp("..", data.cFileName) != 0) {
					LV_ITEM item;
					memset(&item, 0, sizeof(LV_ITEM));
					item.mask = LVIF_TEXT;
					item.pszText    = data.cFileName;
					item.cchTextMax = 255;
					insertItem(&item);
				}

			}
		} while(::FindNextFile(fFile, &data)); 
		::FindClose(fFile);
	}
	delete [] buffer;
}
